$fn = 21;
m4_screw_radius = 4.826/2;
m4_hole_radius = m4_screw_radius * 1.20; 

back_slot_height = case_height - 13;
lid_mount_height = 4;
lid_mount_dim = m4_screw_radius *2 * 2;

rail_width = 20;
slot_width = 6.15;
part_thickness = 1.75;

switch_body_width = 11;
switch_connector_width = 5;
switch_roller_width = 16.25 - switch_body_width;
switch_height = 20;

switch_hole_dia = 2.5 * 1.175  ; //m2 screw dia with margin
switch_hole_spacing = 9.5;

switch_hole_offset_from_bottom = 3;
switch_hole_offset_from_back = 1.5;
switch_buffer = 0.75;

motor_offset_z = 5;
m4_screw_addl_thickness = 4.6;

switch_margin = 2;
motor_offset = 33 - switch_height / 2; // Can subtract out half the switch height to save material. The roller can hit the switch anywhere
motor_offset_y = 11;

// Add & subtract below as appropriate to assure cleareance
bed_slot_inner_width = 10 - 0.15;
bed_slot_depth = 2.5 + 0.15;
bed_slot_width = 6.15 - 0.1;
bed_target_width = 21;
bed_height = 15;

//m4 washer
translate([3 * m4_hole_radius, 3 * m4_hole_radius,0]){
  difference(){
    cylinder(r = m4_hole_radius * 2, h = m4_screw_addl_thickness);
    translate([0,0,-1]){
      cylinder(r = m4_hole_radius , h = m4_screw_addl_thickness * 9);
    }
  }
}

// switch spacer
translate([0,20,0]){
  difference(){
    cube([switch_height, switch_body_width + switch_buffer, motor_offset_z]);
    union(){
      translate([switch_hole_dia/2 + switch_hole_offset_from_bottom,switch_hole_offset_from_back + switch_buffer,-1]){
        cylinder(r = switch_hole_dia/2, h = motor_offset_z * 9);
        translate([switch_hole_spacing,0,0]){
          cylinder(r = switch_hole_dia/2, h = motor_offset_z * 9);
        }
        
    }
  }
}
}
//bed target for switch

translate([0,38,0]){
  linear_extrude(height = bed_target_width){
  
  square(size = [part_thickness, bed_slot_inner_width]);
  translate([part_thickness,0,0]){
    translate([0,bed_slot_inner_width/2 - bed_slot_width/2,0]){      
      square(size = [bed_slot_depth, bed_slot_width]);
    }
    
    translate([bed_slot_depth,0,0]){
      translate([0,bed_slot_inner_width/2 - bed_height/2,0]){
        
        square(size = [bed_slot_depth, bed_height]);
      }
    }
    
    
  }
  
}
  
  
  
  
}