$fn = 20;
switch_height = 20;
switch_width = 6.1;
switch_depth = 10.1;
hole_spacing = 10;
hole_radius = 2.54 /2;
hole_offset = 6;

mounting_screw_radius = 4.86/2;

base_thickness = 2;
base_width = mounting_screw_radius * (2*5);
base_depth = 50;

mounting_hole_radius = mounting_screw_radius * 1.12;

slot_offset_y = 8;
slot_offset_x = 7;

reinforcement_height = 3;
wall_thickness = 1;

slot_depth = base_depth - (mounting_hole_radius * 1.5) -slot_offset_y - wall_thickness;

deck_height = 57;

/**
difference(){
  cube([base_width, base_depth, base_thickness]);
  translate([0,0,-1])
    union(){
      translate([slot_offset_x,slot_offset_y,0]){
        union(){
          cylinder(r=mounting_hole_radius, h = base_thickness + 2);
          translate([-1 * mounting_hole_radius,0,0,]){
            cube([mounting_hole_radius*2, slot_depth, base_thickness +2]);
          }
          translate([0,slot_depth,0]){
            cylinder(r=mounting_hole_radius, h = base_thickness + 2);
          }
          
        }
      }
      
      translate([base_width - slot_offset_x,slot_offset_y,0]){
        union(){
          cylinder(r=mounting_hole_radius, h = base_thickness + 2);
          translate([-1 * mounting_hole_radius,0,0,]){
            cube([mounting_hole_radius*2, slot_depth, base_thickness +2]);
          }
          translate([0,slot_depth,0]){
            cylinder(r=mounting_hole_radius, h = base_thickness + 2);
          }
          
        }
      }
    }
  
}
//one support along depth
translate([0,0,base_thickness]){
  cube([wall_thickness, base_depth, reinforcement_height]);
}

//another support along depth
translate([base_width - wall_thickness,0,base_thickness]){
  cube([wall_thickness, base_depth, reinforcement_height]);
}

//support at the end
translate([0, base_depth - wall_thickness, base_thickness]){
  cube([base_width, wall_thickness, reinforcement_height]);
}

//support at the post
translate([0, 0, base_thickness]){
  cube([base_width, wall_thickness, reinforcement_height]);
}

support_dim = hole_radius * 3.25;
support_height = deck_height - base_thickness;

offset_from_base = 3.5;

translate([base_width/2 - support_dim/2,0,base_thickness]){
  difference(){
    cube([support_dim, support_dim, support_height - offset_from_base]);
    union(){
      translate([0,support_dim/2,support_height - hole_offset - offset_from_base]){
        for(i=[0:2]){
          translate([0,0,-1*hole_radius*2.5*i]){
            rotate([0,90,0]){
              cylinder(r = hole_radius, h = support_dim + 2);
            }
            translate([0,0,-1*hole_spacing]){
             rotate([0,90,0]){
              cylinder(r = hole_radius, h = support_dim + 2);
            } 
            }
          }
        }
      }
    }
  }
}
**/

mounting_block_depth = mounting_hole_radius * 3.75 + 4;
mounting_block_height = base_thickness + reinforcement_height  + 3;
gutter_width = 0.5;
mounting_block_width = base_width + wall_thickness*2 + 2*gutter_width; 

cutout_height = 3;
rail_tab_width = 6.2 - 0.3; // subtract a little so this isn't an interference fit

rail_tab_protrusion = 6.1 - 2;
rail_tab_height = rail_tab_protrusion + 3;

gutter_height = base_thickness + reinforcement_height + 0.5;

translate([-1 * (wall_thickness + gutter_width) , base_depth + 5,0]){
  difference(){
    cube([mounting_block_width, mounting_block_depth, mounting_block_height]);
    union(){
      translate([-1,0,0]){
        translate([wall_thickness*2,0,0]){
          cube([wall_thickness+gutter_width, mounting_block_depth + 2, gutter_height]);
        }
        
        translate([mounting_block_width - wall_thickness - gutter_width,0,0]){
          cube([wall_thickness + gutter_width, mounting_block_depth + 2, gutter_height]);
        }
        
      }
      // bottom cutout
      translate([wall_thickness * 2 - 1 + gutter_width,0,-1]){
        cube([base_width - wall_thickness*2 + 1,mounting_block_depth + 2,base_thickness + 1]);
      }
      
      // top cutout
      translate([wall_thickness * 3 + gutter_width ,wall_thickness,mounting_block_height - cutout_height]){
        cube([base_width - wall_thickness*4,mounting_block_depth - wall_thickness*2,100]);
      }
      
      translate([wall_thickness + slot_offset_x + gutter_width,mounting_block_depth /2,0]){        
        cylinder(r=mounting_hole_radius, h = 100);        
      }
      translate([wall_thickness + (base_width -slot_offset_x) + gutter_width,mounting_block_depth /2,0]){        
        cylinder(r=mounting_hole_radius, h = 100);        
      }
    }
  }
  
  //rail tab on one side
  translate([0, mounting_block_depth/2  - rail_tab_width/2,-1*rail_tab_protrusion]){
    cube([wall_thickness,rail_tab_width,rail_tab_height]);
  }
  
  //rail tab on one side
  translate([mounting_block_width - wall_thickness, mounting_block_depth/2  - rail_tab_width/2,-1*rail_tab_protrusion]){
    cube([wall_thickness,rail_tab_width,rail_tab_height]);
  }
}


